%define	name		BasiliskII
%define version		0.9
%define release		3mdk
%define snapshot	20082001
%define sheepnet	0

# (gb) use '%' instead of '$' so that the shell command is actually
# evaluated instead of being simply propagated in textual form
%define	modversion	%(uname -r)

Summary:		A free, portable Mac II emulator
Name:			%{name}
Version:		%{version}
Release:		%{release}
PreReq:			/usr/sbin/update-alternatives
Source0:		http://iphcip1.physik.uni-mainz.de/~cbauer/%{name}_src_%{snapshot}.tar.bz2
Source1:		BasiliskII.16.xpm.bz2
Source2:		BasiliskII.32.xpm.bz2
Source3:		BasiliskII.48.xpm.bz2
Patch0:			%{name}-0.9-keycodes.patch.bz2
License:		GPL
URL:			http://www.uni-mainz.de/~bauec002/B2Main.html
Group:			Emulators
BuildRoot:		%{_tmppath}/%{name}-%{version}-buildroot
ExclusiveArch:		i386 i486 i586 i687 k6 k7 sparc
BuildRequires:		gcc-cpp, gcc-c++
BuildRequires:		XFree86-devel, XFree86-libs
BuildRequires:		libesound0-devel, libgtk+1.2-devel, libaudiofile0-devel
BuildRequires:		libesound0, libaudiofile0, libbinutils2, libgtk+1.2, libglib1.2

%description
Basilisk II is an Open Source 68k Macintosh emulator. That is, it enables
you to run 68k MacOS software on you computer, even if you are using a
different operating system. However, you still need a copy of MacOS and
a Macintosh ROM image to use Basilisk II (of course MacOS and Mac ROM
are not included in this package).

Some features of Basilisk II:
  - Emulates either a Mac Classic (which runs MacOS 0.x thru 7.5)
    or a Mac II series machine (which runs MacOS 7.x, 8.0 and 8.1),
    depending on the ROM being used
  - Color video display
  - CD quality sound output
  - Floppy disk driver (only 1.44MB disks supported)
  - Driver for HFS partitions and hardfiles
  - CD-ROM driver with basic audio functions
  - Easy file exchange with the host OS via a "Host Directory Tree" icon
    on the Mac desktop
  - Ethernet driver
  - Serial drivers
  - SCSI Manager (old-style) emulation
  - Emulates extended ADB keyboard and 3-button mouse

%if %{sheepnet}
%package sheepnet
Summary:	Basilisk II network module
Group:		Emulators
Requires:	%{name} = %{version}
PreReq:		/bin/mknod
PreReq:		/sbin/depmod, /sbin/insmod, /sbin/lsmod, /sbin/rmmod
PreReq:		kernel

%description sheepnet
This package contains the sheep_net kernel module for
Ethernet networking under Basilisk II.
%endif

%prep
%setup -q
%patch0 -p1 -b .keycodes

%build
cd ./src/Unix
%configure
%make

%if %{sheepnet}
cd Linux/NetDriver
make CC=kgcc
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT%{_prefix}/bin
install -d -m 755 $RPM_BUILD_ROOT%{_prefix}/lib
install -d -m 755 $RPM_BUILD_ROOT%{_mandir}/man1
%if %sheepnet
install -d -m 755 $RPM_BUILD_ROOT/lib/modules/%{modversion}/misc
%endif
cd ./src/Unix
%makeinstall

%if %sheepnet
# install the sheep_net module
cd ./Linux/NetDriver
install -m 644 sheep_net.o $RPM_BUILD_ROOT/lib/modules/%{modversion}/misc
# (gb) copy sources in case the module has to be rebuilt
install -d -m 755 $RPM_BUILD_ROOT/%{_datadir}/%{name}-sheepnet
install -m 644 Makefile $RPM_BUILD_ROOT/%{_datadir}/%{name}-sheepnet
install -m 644 sheep_net.c $RPM_BUILD_ROOT/%{_datadir}/%{name}-sheepnet
%endif

# mdk icons
mkdir -p $RPM_BUILD_ROOT%{_iconsdir}
mkdir -p $RPM_BUILD_ROOT%{_liconsdir}
mkdir -p $RPM_BUILD_ROOT%{_miconsdir}
bzcat %{SOURCE1} > $RPM_BUILD_ROOT%{_miconsdir}/%{name}.xpm
bzcat %{SOURCE2} > $RPM_BUILD_ROOT%{_iconsdir}/%{name}.xpm
bzcat %{SOURCE3} > $RPM_BUILD_ROOT%{_liconsdir}/%{name}.xpm

# mdk menu
mkdir -p $RPM_BUILD_ROOT%{_menudir}
cat > $RPM_BUILD_ROOT%{_menudir}/%{name} << EOF
?package(%{name}):\
    command="%{_bindir}/%{name}"\
    title="Basilisk II"\
    icon="%{name}.xpm"\
    longtitle="A Macintosh Emulator"\
    needs="x11"\
    section="Applications/Emulators"
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_menus
update-alternatives --install %{_bindir}/basilisk2 basilisk2 %{_bindir}/%{name} 10 \
	--slave %{_mandir}/man1/basilisk2.1.bz2 basilisk2.1.bz2 %{_mandir}/man1/%{name}.1.bz2

%postun
%clean_menus
[ $1 = 0 ] || exit 0
update-alternatives --remove basilisk2 %{_bindir}/%{name}

%if %sheepnet
%post sheepnet
# rebuild module if kernel is not the same on the target system
modversion="`uname -r`"
if [ "$modversion" != "%{modversion}" ]; then
	/bin/echo -n "Kernel version mismatch. Rebuilding the sheep_net module... "
	mkdir -p /tmp/sheep_net
	cd /tmp/sheep_net
	cp %{_datadir}/%{name}-sheepnet/{Makefile,sheep_net.c} .
	(make CC=kgcc >/dev/null 2>&1 && echo "Done") || (echo "Failure"; exit 1)
	install -d -m 755 /lib/modules/$modversion/misc
	install -m 644 sheep_net.o /lib/modules/$modversion/misc
	rm -rf /tmp/sheep_net
fi
/sbin/depmod -a

# install sheep_net module
/sbin/lsmod | grep sheep_net > /dev/null
if [ $? -eq 0 ]; then
	/sbin/rmmod sheep_net
fi

# create sheep_net device
/sbin/insmod /lib/modules/$modversion/misc/sheep_net.o
if [ ! -r "/dev/sheep_net" ]; then
	/bin/echo -n "Creating the sheep_net device... "
	cd %{_datadir}/%{name}-sheepnet
	(make dev >/dev/null 2>&1 && echo "Done") || (echo "Failure"; exit 1)
fi

%postun sheepnet
/sbin/lsmod | grep sheep_net > /dev/null
if [ $? -eq 0 ]; then
	/sbin/rmmod sheep_net
fi
rm -f /dev/sheep_net
rm -f /lib/modules/`uname -r`/misc/sheep_net.o
/sbin/depmod -a
%endif

%files
%defattr(-,root,root)
# docs
%doc README TECH TODO COPYING ChangeLog
%{_mandir}/man1/%{name}.1*
#
%{_bindir}/BasiliskII
# data
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/fbdevices
%{_datadir}/%{name}/keycodes
# mdk icons
%{_miconsdir}/%{name}.xpm*
%{_iconsdir}/%{name}.xpm*
%{_liconsdir}/%{name}.xpm*
# mdk menus
%{_menudir}/%{name}

%if %sheepnet
%files sheepnet
%defattr(-,root,root)
%dir %{_datadir}/%{name}-sheepnet
%{_datadir}/%{name}-sheepnet/Makefile
%{_datadir}/%{name}-sheepnet/sheep_net.c
# RPM doesn't accept %{modversion} here
/lib/modules/*
%endif

%changelog
* Mon Aug 20 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.9-3mdk
- Update to CVS snapshot 2001/08/20, which brings:
  - Bug fixes to runtime depth and resolution switching code
  - Compilation fixes with gcc-3.0.1
  - Disable constants merging since it breaks the FPU emulation core.
    i.e. Add -fno-merge-constants to CXXFLAGS
- Set "basilisk2" as an alternative name for the binary and the man page

* Mon Jul  2 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.9-2mdk
- updated to CVS snapshot 2001/07/02, which brings:
- runtime resolution switching
- runtime depth switching ({1,2,4,8}-bit on {16,32}-bit displays)

* Tue Jun  5 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.9-1mdk
- release 0.9
- updated description
- added mdk menus and icons
- added "Conflicts" tag with BasiliskII-jit

* Mon Apr  9 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.9-0.4mdk
- sanitized specfile (s/Copyright/License, BuildRequires, etc.)
- updated to CVS snapshot 09042001, which brings:
- thread initialization for "serial" emulation
- fix for do_fmod() in i386-optimized FPU core

* Wed Mar 28 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.9-0.3mdk
- fixed sheep_net module auto-rebuild in %post
- fixed sheep_net module removal in %postun
- shortened ServerVendor matching string to "Linux Mandrake" (patch1)
- updated to CVS snapshot 27032001, which brings:
- updated sheep_net module for 2.4.x kernels but not packaged per Chmou's request
- performance improvements to screen update code
- fix and additions to 68040 emulation (MOVE16 instructions)

* Sun Mar 11 2001 Giuseppe Ghib <ghibo@mandrakesoft.cm> 0.9-0.2mdk
- Fixed %description according to Randy Kramer suggestion.

* Sun Mar 11 2001 Giuseppe Ghib <ghibo@mandrakesoft.cm> 0.9-0.1mdk
- updated to snapshot 17022001.
- temporary removed sheep_net module (problems with kernel 2.4 compiling).

* Fri Nov 17 2000 David BAUDENS <baudens@mandrakesoft.com> 0.8-15mdk
- Rebuild with gcc-2.96 & glibc-2.2

* Tue Aug 29 2000 Giuseppe Ghib <ghibo@mandrakesoft.com> 0.8-14mdk
- use of %%{_mandir}.
- updated to new snapshot version 13072000.

* Mon Aug 07 2000 Frederic Lepied <flepied@mandrakesoft.com> 0.8-13mdk
- automatically added BuildRequires.

* Sun May 14 2000 David BAUDENS <baudens@mandrakesoft.com> 0.8-12mdk
- Fix unresolved symbol for sheepnet.

* Sat May 13 2000 David BAUDENS <baudens@mandrakesoft.com> 0.8-11mdk
- Don't optimize for i586 when this package is builded for another x86 arch.
- Update kernel version.

* Sat Apr 29 2000 Giuseppe Ghib <ghibo@mandrakesoft.com> 0.8-10mdk
- merged with my previous changes
- rebuild with latest kernel.
- updated keycodes patch.

* Wed Apr  5 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.8-9mdk
- Spec-helper.
- Fix groups.
- Add Prereq kernel for sheepnet pacakge to don't fail on depmod.

* Wed Mar 22 2000 Giuseppe Ghib <ghibo@mandrakesoft.com>
- updated to 14032000 snapshot.

* Mon Feb 07 2000 Giuseppe Ghib <ghibo@linux-mandrake.com>
- updated to 0.8-1 (0012000).

* Fri Jan 21 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.8-8mdk
- don't build on alpha.

* Thu Jan 13 2000 Francis Galiegue <francis@mandrakesoft.com>
- reintegrated CFLAGS hack, but made it architecture dependant. Leave only -O2
  for archs other than ix86.

* Tue Jan 11 2000 Francis Galiegue <francis@mandrakesoft.com>
- Removed CFLAGS= in ./configure - non portable

* Mon Jan 03 2000 Giuseppe Ghib <ghibo@linux-mandrake.com>
- updated to snapshot 22111999.

* Mon Dec 20 1999 Giuseppe Ghib <ghibo@linux-mandrake.com>
- rebuild for new kernel version.

* Sat Nov 06 1999 Giuseppe Ghib <ghibo@linux-mandrake.com>
- updated to snapshot 02111999.
 
* Sat Oct 25 1999 Giuseppe Ghib <ghibo@linux-mandrake.com>
- mandrake adaptions
- removed patch for changing 'keycodes' path
- added patch for 'keycodes' files (XFree86 vendor string)
- split package in main and sheepnet
- added BuildPreReq

* Sun Aug 14 1999 Arne Coucheron <arneco@online.no>
  [250799-2]
- corrected the path definition of the keycode file

* Sun Aug 14 1999 Arne Coucheron <arneco@online.no>
  [250799-1]
- first RPM build
